
/*
**  VFDシールド　スケッチ
**
**  ノリタケ伊勢電子製　GU-3900シリーズモジュールを
**　RS-232Cシリアル接続でつないでみました。
**      2012/8/23
*/
//   ピン配置
//int vfd_RxD   = 0;   
//int vfd_TxD   = 1;  
int vfd_RTS   = 2;
int vfd_CTS   = 3; 
int sw_blue   = 12;  //  青ボタン
int sw_red    = 13;  //　赤ボタン

// 作成した関数のプロトタイプ

void vfd_put(unsigned char onebyte);
void vfd_print(unsigned char message[], int L);
void vfd_crlf();
void vfd_kanjiOn();
void vfd_setCursor(int X, int Y);

// the setup routine runs once when you press reset:
// リセット後に１回だけ実行されるプログラム
void setup() {                
  // initialize the digital pins
  pinMode(vfd_RTS, OUTPUT);
  pinMode(vfd_CTS, INPUT);
  pinMode(sw_blue, INPUT_PULLUP);
  pinMode(sw_red, INPUT_PULLUP);
 
  Serial.begin(38400);
  Serial.print("Hello world"); // 少しならそのまま書き込みできます。
  vfd_crlf();  //改行
  unsigned char message[12] = "Hello World";
  vfd_print(message, sizeof(message)-1);
  vfd_crlf();  //改行
  vfd_crlf();  //改行  
    vfd_kanjiOn();
  unsigned char  kanji_code[ 10 ] =
  {   /***  蛍   光   表   示   管   S-JIS code *****/
      0x8c,  0x75,  0x8c,  0xf5,  0x95,  0x5c,  0x8e,  0xa6,  0x8a,  0xc7,   };
      vfd_print(kanji_code, 10);
 }

// the loop routine runs over and over again forever:
// 繰り返し実行されるプログラム
void loop() {
    if(digitalRead(sw_red) == LOW) //赤ボタン
       { vfd_setCursor(100,1); // カーソル移動
        vfd_put(0x90);       //　"赤"
        vfd_put(0xd4);
      }
    if(digitalRead(sw_blue) == LOW) //青ボタン
      {  vfd_setCursor(100,1); // カーソル移動
        vfd_put(0x90);        //　"青"
        vfd_put(0xc2);
      }
}
void vfd_put(unsigned char onebyte)
{
    while( digitalRead(vfd_CTS) == HIGH){}
    Serial.write( onebyte);
}
void vfd_print(unsigned char message[], int L)
{
 int i;
 for(i=0; i<L; i++)
  {
     vfd_put(message[i]);
  } 
}
void vfd_crlf()
{
  vfd_put(0x0d);
  vfd_put(0x0a);
}
void vfd_kanjiOn()
{
 unsigned char data[15];
   data[0]=0x1f;
   data[1]=0x28;
   data[2]=0x67;
   data[3]=0x01;
   data[4]=0x02;
   data[5]=0x1f;
   data[6]=0x28;
   data[7]=0x67;
   data[8]=0x02;
   data[9]=0x01;
   data[10]=0x1f;
   data[11]=0x28;
   data[12]=0x67;
   data[13]=0x0f;
   data[14]=0x00;
  vfd_print(data,15);
}
void vfd_setCursor(int X, int Y)
{
 unsigned char data[6];
  data[0] = 0x1f; 
  data[1] = 0x24;
  data[2] = X % 256;
  data[3] = X / 256;
  data[4] = Y % 256;
  data[5] = Y / 256;
  vfd_print(data,6);
}


